package cokr.xit.fims.sndb.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

import cokr.xit.fims.sndb.Sndng;
import cokr.xit.fims.sndb.SndngDtl;
import cokr.xit.fims.sndb.SndbQuery;

/** 발송 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-25	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("sndngMapper")
public interface SndngMapper extends AbstractMapper {

	/**지정한 조건에 따라 발송 대장 목록을 조회하여 반환한다.<br />
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> selectSndngList(SndbQuery req);

	/**지정한 조건에 따라 발송 대장 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<DataObject> selectSndngs(SndbQuery req);

	/**발송 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"sndng" - 발송 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertSndng(Map<String, Object> params);

	/**발송 대장 정보를 등록한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insertSndng(Sndng sndng) {
		return sndng != null && insertSndng(params().set("sndng", sndng)) == 1;
	}

	/**발송 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"sndng" - 발송 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateSndng(Map<String, Object> params);

	/**발송 대장 정보를 수정한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean updateSndng(Sndng sndng) {
		return sndng != null && updateSndng(params().set("sndng", sndng)) == 1;
	}

	/**지정한 발송 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"sndng" - 발송 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteSndng(Map<String, ?> params);

	/**발송 대장 정보를 삭제한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean deleteSndng(Sndng sndng) {
		return sndng != null && deleteSndng(params().set("sndng", sndng)) == 1;
	}

	/**지정한 조건에 따라 발송 상세 목록을 조회하여 반환한다.<br />
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 목록
	 */
	List<DataObject> selectSndngDtlList(SndbQuery req);

	/**지정한 조건에 따라 발송 상세 객체들을 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 객체 목록
	 */
	List<DataObject> selectSndngDtls(SndbQuery req);

	/**발송 상세 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"sndngDtl" - 발송 상세</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertSndngDtl(Map<String, Object> params);

	/**발송 상세 정보를 등록한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insertSndngDtl(SndngDtl sndngDtl) {
		return sndngDtl != null && insertSndngDtl(params().set("sndngDtl", sndngDtl)) == 1;
	}

	/**발송 상세 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"sndngDtl" - 발송 상세</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateSndngDtl(Map<String, Object> params);

	/**발송 상세 정보를 수정한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean updateSndngDtl(SndngDtl sndngDtl) {
		return sndngDtl != null && updateSndngDtl(params().set("sndngDtl", sndngDtl)) == 1;
	}

	/**지정한 발송 상세을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"sndngDtl" - 발송 상세</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteSndngDtl(Map<String, ?> params);

	/**발송 상세 정보를 삭제한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean deleteSndngDtl(SndngDtl sndngDtl) {
		return sndngDtl != null && deleteSndngDtl(params().set("sndngDtl", sndngDtl)) == 1;
	}

}
